/*
Plugin: jQuery Parallax
Version 1.1.3
Author: Ian Lunn - Edited By Nolan Campbell
Twitter: @IanLunn
Author URL: http://www.ianlunn.co.uk/
Plugin URL: http://www.20script.ir licensed under the MIT and GPL licenses:
http://www.opensource.org/licenses/mit-license.php
http://www.gnu.org/licenses/gpl.html
*/

(function( $ ){
	var $window = $(window);
	var windowHeight = $window.height();

	$window.resize(function () {
		windowHeight = $window.height();
	});

	$.fn.siparallax = function(xpos, speedFactor, outerHeight, dur, eas) {
		var $this = $(this);
		var getHeight;
		var firstTop;
		var paddingTop = 0;
		
		//get the starting position of each element to have parallax applied to it		
		$this.each(function(){
		    firstTop = $this.offset().top;
		});

		if (outerHeight) {
			getHeight = function(jqo) {
				return jqo.outerHeight(true);
			};
		} else {
			getHeight = function(jqo) {
				return jqo.height();
			};
		}
			
		// setup defaults if arguments aren't specified
		if (arguments.length < 1 || xpos === null) xpos = "50%";
		if (arguments.length < 2 || speedFactor === null) speedFactor = 0.1;
		if (arguments.length < 3 || outerHeight === null) outerHeight = true;

		if (arguments.length < 4 || dur === null) dur = 1;
		if (arguments.length < 5 || eas === null) eas = 'linear';
		
		// function to be called whenever the window is scrolled or resized
		function update(){
			var pos = $window.scrollTop();

			$this.each(function(){
				var $element = $(this);
				var top = $element.offset().top;
				var height = getHeight($element);
               if($this.data('inview') == true){
				// Check if totally above or totally below viewport
				if (top + height < pos || top > pos + windowHeight) {
					return;
            	}
                };
              var type = 'top';
               var direction = 'up';

              if($this.data('type')){
              type = $this.data('type');
              };

               if($this.data('direction')){
              direction = $this.data('direction');
              };

              //start
              if(type == 'top'){
               if($this.hasClass('no-animate')){
                if(direction == 'up'){
				$this.css({'top'  :  Math.round((firstTop - pos) * speedFactor) + "px"});
                }else{
                	$this.css({'top'  :  Math.round((firstTop + pos) * speedFactor) + "px"});
                }
                }else {
                   if(direction == 'up'){
                $this.stop().animate({'top'  :  Math.round((firstTop - pos) * speedFactor) + "px"}, dur, eas);
                }else{
                  $this.stop().animate({'top'  :  Math.round((firstTop + pos) * speedFactor) + "px"}, dur, eas);
                }
                }
             }else if(type == 'margin-top'){

               if($this.hasClass('no-animate')){
                  if(direction == 'up'){
				$this.css({'margin-top'  :  Math.round((firstTop - pos) * speedFactor) + "px"});
                }else{
                 	$this.css({'margin-top'  :  Math.round((firstTop + pos) * speedFactor) + "px"});
                }
                }else {
                    if(direction == 'up'){
                $this.stop().animate({'margin-top'  :  Math.round((firstTop - pos) * speedFactor) + "px"}, dur, eas);
                }else{
                  $this.stop().animate({'margin-top'  :  Math.round((firstTop + pos) * speedFactor) + "px"}, dur, eas);
                }
                }

             }else if(type == 'bottom'){
              if($this.hasClass('no-animate')){
                if(direction == 'up'){
				$this.css({'bottom'  :  Math.round((firstTop + pos) * speedFactor) + "px"});
                }else{
                	$this.css({'bottom'  :  Math.round((firstTop - pos) * speedFactor) + "px"});
                }
                }else {
                   if(direction == 'up'){
                $this.stop().animate({'bottom'  :  Math.round((firstTop + pos) * speedFactor) + "px"}, dur, eas);
                }else{
                  $this.stop().animate({'bottom'  :  Math.round((firstTop - pos) * speedFactor) + "px"}, dur, eas);
                }
                }
             }else if(type == 'margin-bottom'){
                if($this.hasClass('no-animate')){
                  if(direction == 'up'){
				$this.css({'margin-bottom'  :  Math.round((firstTop - pos) * speedFactor) + "px"});
                }else{
                 	$this.css({'margin-bottom'  :  Math.round((firstTop + pos) * speedFactor) + "px"});
                }
                }else {
                    if(direction == 'up'){
                $this.stop().animate({'margin-bottom'  :  Math.round((firstTop - pos) * speedFactor) + "px"}, dur, eas);
                }else{
                  $this.stop().animate({'margin-bottom'  :  Math.round((firstTop + pos) * speedFactor) + "px"}, dur, eas);
                }
                }
             }
            //end




			});
		}

		$window.bind('scroll', update).resize(update);
		update();
	};
})(jQuery);
